type TObject = {
    [key: string | number | symbol]: any;
};
/**
 * Base module with data only.
 */
export default class DataController<Data = TObject> {
    data: Data;
    private readonly defaultData;
    constructor(defaultData: Data);
    setData(data: Partial<Data> | keyof Data, value?: Data[keyof Data]): void;
    resetData(...keep: (keyof Data)[]): void;
}
export {};
