type TObject = {
    [key: string | number | symbol]: any;
};
/**
 * Base module with state only.
 */
export default class StateController<State = TObject> {
    state: State;
    private readonly defaultState;
    constructor(defaultState: State);
    setState(state: Partial<State> | keyof State, value?: State[keyof State]): void;
    resetState(...keep: (keyof State)[]): void;
}
export {};
