const storeInstances = new Map();
export default function useStore(store) {
    if (storeInstances.has(String(store))) {
        return storeInstances.get(String(store));
    }
    const instance = new store();
    storeInstances.set(String(store), instance);
    return instance;
}
